---
name: "\U0001F41BBug report"
about: Create a report to help us improve fuzzuf.
title: ''
labels: bug
assignees: ''

---


<!-- Please set the title summarizing a task that should be discussed in Issue -->

## Relation to existing issues
<!-- If the bug relates to one of existing issues, please write down the URL. Leave N/A explicitly otherwise -->

## Relation to existing roadmaps
<!-- If the bug relates to one of existing roadmaps (e.g. TODO.md), please write down the URL. Leave N/A explicitly otherwise -->

## Bug explanation
<!-- Please explain the bug you encountered -->

## Steps to reproduce
<!-- Describe the procedures to reproduce the bug in a step-by-step manner -->

1.
2.
3.

### Environment

- fuzzuf version or commit ID:
- OS:
- (Optional) Other libraries and their versions:

## Expected behaviors
<!-- What is the expected behavior if there were no such bug? -->

## Error messages, stack traces, or logs
<!-- Please paste logs that seem to be useful for bug reproduction and inspection here -->

## Supplementary information (optional)
<!-- If you have any supplementary information for bug causes, please desceibe here -->

---
> Authors of this issue must fill the checklist below when they submit it

#### Mandatory entries
- [ ] The title of this issue clearly summarizes the bug
- [ ] The relations to existing issues and roadmaps are stated if they exist
- [ ] Each entry above has been filled

---
> A repository maintainer will set up an asignee for each issue.
> Asignee must check this issue from the perspective of the checklist below before going through a full-fledged bug-fix, and leave the initial comment.
> Copy to your comment and fill out the checklist on that occasion.

#### Optional entries
- [ ] If the bug is going to be fixed, it has been commented
- [ ] If it is not going to be fixed and this issue is closed, it has been commented

#### Mandatory entries
- [ ] Have checked relationships to existing issues and roadmaps
- [ ] The minimum required information to reproduce the bug and spot the root cause is included

---
> If an assignee is going to solve the task for this issue, consider the policy and divide the procedures into the checklist.
> Once divided, write down the checklist to the comment.
> Each step for the procedures must correspond to one single pull request. Once the PR is made, update the checklist.
> If the procedures are remained undecided, or need additional reviews, update the checklist appropriately with the discussion here.

#### Procedure checklist
- [ ] Write down the step 1
    - If you have choices rejected, add as an item here with the reasons of rejection
- [ ] Write down the step 2
    - Ditto
- [ ] ...

---
> If an assignee finishes solving the task for this issue, copy the following checklist to the comment and fill it out.

#### Optional entries
- [ ] If you have remaining tasks, relating issues have been created or updated
- [ ] If the changes against this issue affect the milestone (e.g. TODO.md), the necessity of version upgrading has already been discussed
- [ ] If new tests are required to guarantee the changes against this issue, they have been split to the checklist
- [ ] If entries in the checklist are hard to understand, that has been pointed out
- [ ] If the discussion concludes that the design concept should be documented appropriately, an assignee has checked additional documents and source codes
- [ ] If there were uncertainties during the discussion, all of them have been resolved

#### Mandatory entries
- [ ] The procedure checklist is not required to update any longer
- [ ] The PRs correspond to each entries of the checklist have adopted the best way to solve the problems as long as an assignee can come up with
- [ ] All the PRs correspond to each entries of the checklist have already been merged
- [ ] This issue can be closed

--
> If an assignee agrees to close the issue without solving the tasks relating it, describe the reasons in the comment.
> Then, copy the following checklist to the comment and fill them out.

#### Mandatory entries
- [ ] The reason to close the issue has been agreed among assignees
- [ ] This issue can be closed
