---
name: "\U0001F4A1Feature request"
about: Suggest an idea for fuzzuf.
title: ''
labels: feature
assignees: ''

---

<!-- Please set the title summarizing a task that should be discussed in Issue -->

## Relation to existing issues
<!-- If the feature request relates to one of existing issues, please write down the URL. Leave N/A explicitly otherwise -->

## Relation to existing roadmaps
<!-- If the feature request relates to one of existing roadmaps (e.g. TODO.md), please write down the URL. Leave N/A explicitly otherwise -->

## Motivation
<!-- Please write the motivation for the proposal.
If your feature request is related to a problem, please describe a clear and concise description of what the problem is. -->

## Description
<!-- Please write a detailed description of the new feature. -->

## Alternatives (optional)
<!-- Please write a clear and concise description of any alternative solutions or features you've considered. -->

## Additional context (optional)
<!-- Please add any other context or screenshots about the feature request here. -->

---
> Authors of this issue must fill the checklist below when they submit it

#### Mandatory entries
- [ ] The title of this issue clearly summarizes the feature request
- [ ] The relations to existing issues and roadmaps are stated if they exist
- [ ] Each entry above has been filled


---
> A repository maintainer will set up an asignee for each issue.
> Asignee must check this issue from the perspective of the checklist below before going through a full-fledged feature addition, and leave the initial comment.
> Copy to your comment and fill out the checklist on that occasion.

#### Optional entries
- [ ] If the feature request is going to be accepted, it has been commented
- [ ] If it is not going to be accepted and this issue is closed, it has been commented

#### Mandatory entries
- [ ] Have checked relationships to existing issues and roadmaps

---
> If an assignee is going to solve the task for this issue, consider the policy and divide the procedures into the checklist.
> Once divided, write down the checklist to the comment.
> Each step for the procedures must correspond to one single pull request. Once the PR is made, update the checklist.
> If the procedures are remained undecided, or need additional reviews, update the checklist appropriately with the discussion here.

#### Procedure checklist
- [ ] Write down the step 1
    - If you have choices rejected, add as an item here with the reasons of rejection
- [ ] Write down the step 2
    - Ditto
- [ ] ...

---
> If an assignee finishes solving the task for this issue, copy the following checklist to the comment and fill it out.

#### Optional entries
- [ ] If you have remaining tasks, relating issues have been created or updated
- [ ] If the changes against this issue affect the milestone (e.g. TODO.md), the necessity of version upgrading has already been discussed
- [ ] If new tests are required to guarantee the changes against this issue, they have been split to the checklist
- [ ] If entries in the checklist are hard to understand, that has been pointed out
- [ ] If the discussion concludes that the design concept should be documented appropriately, an assignee has checked additional documents and source codes
- [ ] If there were uncertainties during the discussion, all of them have been resolved

#### Mandatory entries
- [ ] The procedure checklist is not required to update any longer
- [ ] The PRs correspond to each entries of the checklist have adopted the best way to solve the problems as long as an assignee can come up with
- [ ] All the PRs correspond to each entries of the checklist have already been merged
- [ ] This issue can be closed

--
> If an assignee agrees to close the issue without solving the tasks relating it, describe the reasons in the comment.
> Then, copy the following checklist to the comment and fill them out.

#### Mandatory entries
- [ ] The reason to close the issue has been agreed among assignees
- [ ] This issue can be closed  
